"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EncounterCreator = void 0;
const MonsterService_1 = require("../services/monsters/MonsterService");
class EncounterCreator {
    constructor() {
        this.monsterService = new MonsterService_1.MonsterService();
    }
    getRandomMonsters(numberOfMonsters = 1, challengeRating = null) {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            const monsters = yield this.monsterService.getAll({
                params: { challenge_rating: challengeRating },
            });
            const randomMonsters = [];
            for (let i = 0; i < numberOfMonsters; i++) {
                const random = Math.floor(Math.random() * monsters.count);
                const monsterIndex = (_a = monsters.results[random]) === null || _a === void 0 ? void 0 : _a.index;
                if (monsterIndex) {
                    const monster = yield this.monsterService.getOne(monsterIndex);
                    randomMonsters.push(monster);
                }
            }
            return randomMonsters;
        });
    }
}
exports.EncounterCreator = EncounterCreator;
